<?php
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/common.php';
include_once $path . '/Model_adm.php';
include_once $path . '/plugin/plan/Model_plan.php';
include_once $path . '/plugin/plan/Controller_plan.php';

$controller = new Controller_Plan($path, $dbconnection, $user);

// Check if user has map_view right
if(!$controller->isUserPerms['view'])
{
	$smarty->display('no_access.html');
	exit(0);
}
$smarty->assign('isUserPerms', $controller->isUserPerms);

// Action
if(isset($_GET['action']))
{
    $action = $_GET['action'];
}
elseif(isset($_POST['action']))
{
    $action = $_POST['action'];
}
else
{
    $action = 'plan';
}

$errors = array();
// Secondary actions wich can redirect to a main action or stop the script after being processed
if($action == 'details')
{
	// Open node status pop-up when ctrl+right-click on object linked to node.
	$alerts = array();
	if(isset($_GET['objectid']) && !empty($_GET['objectid']))
	{
		$alerts = $controller->getAlertsByElement($lang, null, $alerts, $_GET['objectid']);
	}
	elseif(isset($_GET['id']) && !empty($_GET['id']))
	{
		$alerts = $controller->getAlertsByElement($lang, $_GET['id'], $alerts);
	}

	if(!empty($alerts))
	{
		echo json_encode($alerts);
	}
	else
	{
		echo json_encode(null);
	}
	exit(0);
}
elseif($action == 'getPlanState')
{
	if(isset($_GET['id']) && !empty($_GET['id']))
	{
		$id = $_GET['id'];
		$state = 0;
		$alerts = array();
		$alerts = $controller->getAlertsByElement($lang, $id, $alerts);

		if(!empty($alerts))
		{
			if(!empty($alerts['nodes']))
			{
				foreach($alerts['nodes'] as $alert)
				{
					$state = $controller->priority_state($controller::ALERTS_PRIORITIES, $state, $controller::ALERTS_STATES[$alert['state']]);

				}
			}
			if(!empty($alerts['groups']))
			{
				foreach($alerts['groups'] as $alert)
				{
					$state = $controller->priority_state($controller::ALERTS_PRIORITIES, $state, $controller::ALERTS_STATES[$alert['state']]);
				}
			}
		}
		else
		{
			echo json_encode($state);
			exit(0);
		}
	}
	else
	{
		echo json_encode(null);
		exit(0);
	}

	echo json_encode($state);
	exit(0);
}
elseif($action == 'getPlanTypes')
{
	$types = Model_plan::getPlanType($dbconnection);
	echo json_encode($types);
	exit(0);
}
elseif($action == 'getPlanType')
{
	if(isset($_GET['id']) && !empty($_GET['id']))
	{
		$controller = Model_plan::getPlanType($dbconnection, $_GET['id'])[0]['controller'];
		echo json_encode($controller);
	}
	else
	{
		echo json_encode(null);
	}
	exit(0);
}
elseif($action == 'delPict')
{
	if(!empty($_POST['idPlan']) && isset($_POST['idPlan']))
	{
		$img = $_POST['img'];
		$idPlan = $_POST['idPlan'];
		$_GET['id'] = $idPlan;

		try
		{
			if($img!="min_empty.jpg") // IMAGE BLANCHE PEUT PAS ETRE SUPPRIME
			{
				$returDelImg = unlink($controller->pathDataPlans."miniature/".$img);
				if($returDelImg == true)
				{
					$nameImg = explode("min_", $img);
					$returDelImg = unlink($controller->pathDataPlans.$nameImg[1]);
					if($returDelImg == true)
					{
						$smarty->assign('success_message', $lang['PLAN_DELETE_IMAGE_TEXT']);
						$action = 'admin';
					}
					else
					{
						throw new Exception('File img not writable');
					}
				}
				else
				{
					throw new Exception('File img miniature not writable');
				}
			}
			else
			{
				throw new Exception('File img esia not writable');
			}
		}
		catch (EsiaDbException $e)
		{
			$errors[] = $e->getMessage();
		}
		catch (Exception $e)
		{
			$errors[] = $e->getMessage();
		}
	}
	else
	{
		$img = $_GET['img'];
		$idPlan = $_GET['id'];

		$smarty->assign('id', $idPlan);
		$smarty->assign('img', $img);

		$smarty->assign('action', 'delPict');
	}
}

// Plan actions wich required to get plan informations
// Gather plan informations
$plan = null;
$planId = null;
if(!empty($_GET['id']) && is_numeric($_GET['id']))
{
	$planId = intval($_GET['id']);
	$plan = Model_plan::getPlan($dbconnection, $planId)[$planId];
	$isUserPlanPrivilege = $controller->checkUserPlanPrivilege($planId);
}
// Check if page can be displayed
if(empty($plan) || !$isUserPlanPrivilege['READ'])
{
	$smarty->display('no_access.html');
	exit(0);
}
$smarty->assign('isUserPlanPrivilege', $isUserPlanPrivilege);

// Actions
if($action == 'delPlan')
{
	$smarty->assign('idplan', $planId);
	// Authorize deletion only if the plan id from the confirmation form is the same than the requested plan id to delete
	if ($_POST['confirmIdPlan'] == $planId) {
		if ($controller->isUserPerms['admin'] && $isUserPlanPrivilege['WRITE']) {
			try
			{
				Model_Plan::updateObjLinkedPlan($dbconnection, $planId); // Remove references between objects & plan
				Model_Plan::deleteAllObjOnPlan($dbconnection, $planId); // Remove objects
				Model_Plan::deletePlan($dbconnection, $planId); // Remove plan
			}
			catch (EsiaDbException $e)
			{
				$errors[] = $e->getMessage();
			}

			if (empty($errors)) {
				$url = $controller->pluginURL . $controller::FOLDERS_CONTROLLER . "?";
				if(!empty($plan['folders']))
                {
                    $url .= "id=" . $plan['folders'] . "&";
                }
                $url .= "delete_success=plan";

				ob_end_clean();
				header("Location: $url");
				exit(0);
			}
		}
		else {
			$errors[] = $lang['PLAN_USER_PERMS_DENIED'];
		}
	}
}
elseif($action == 'editinfos')
{
	if ($controller->isUserPerms['admin'] && $isUserPlanPrivilege['WRITE']) {
		if(isset($_POST['plan_name']) && !empty($_POST['plan_name']))
		{
			try
			{
				// Update DB plan_plans table
				$name = $_POST['plan_name'];
				$type = $plan['type_id'];
				$params = null;
				$parent = null;
				if(isset($_POST['folder_parent']))
				{
					$parent = $_POST['folder_parent'];
				}

				// Update DB plan_users_access table
				$currentUsersAccessRight = Model_Plan::getPlanUserAccess($dbconnection, $planId);
				$newAccessUsersIds = $controller->setReadWritePrivilegeList($currentUsersAccessRight, $_POST['read_userplan'], $_POST['write_userplan']);
				// Update privilèges
				Model_plan::updatePlanPrivilege($dbconnection, $planId, $newAccessUsersIds['READ'], 'READ');
				Model_plan::updatePlanPrivilege($dbconnection, $planId, $newAccessUsersIds['WRITE'], 'WRITE');

				// Update image background
				if($_FILES['hiddenfile']['name']!=null) // Si une nouvelle image
	            {
	                //test si il n'y a pas d'erreur
	                if ($_FILES['hiddenfile']['error'])
	                {
	                    switch ($_FILES['hiddenfile']['error'])
	                    {
	                        case 1: // UPLOAD_ERR_INI_SIZE
	                            throw new Exception('file exceeds the maximum size by server (php.ini)'); break;
	                        case 2: // UPLOAD_ERR_FORM_SIZE
	                            throw new Exception('file exceeds the maximum size by HTML form'); break;
	                        case 3: // UPLOAD_ERR_PARTIAL
	                            throw new Exception('File transfer was interrupted'); break;
	                        case 4: // UPLOAD_ERR_NO_FILE
	                            throw new Exception('the size of file was null'); break;
	                        default:  throw new Exception('Unknown error');
	                    }
	                }
					// Clean file name to avoid unexpected chars like é,&,@,...
					$_FILES['hiddenfile']['name'] = strtolower(trim(preg_replace('/[^A-Za-z0-9-\.]+/', '-', $_FILES['hiddenfile']['name'])));

	                if(!file_exists($controller->pathDataPlans.$_FILES['hiddenfile']['name'])) // Si elle n'existe pas déjà
	                {
	                    if(move_uploaded_file($_FILES['hiddenfile']['tmp_name'],$controller->pathDataPlans.$_FILES['hiddenfile']['name'])==true) // Si le dwl s'est bien passé
	                    {
	                        $params['imageHeader']="min_".$_FILES['hiddenfile']['name'];

	                        //thumbnail creation
	                        preg_match("/.(\w*)$/", $_FILES['hiddenfile']['name'], $match);
	                        if(is_array($match))
	                        {
	                            $file_ext=$match[1];
	                        }

	                        $thumbnail = $controller->pathDataPlans."miniature/min_".$_FILES['hiddenfile']['name'];
	                        $upload_image = $controller->pathDataPlans.$_FILES['hiddenfile']['name'];

	                        list($width,$height) = getimagesize($upload_image);
	                        $ratio = $width/$height;
	                        $NouvelleHauteur = 58;
	                        $NouvelleLargeur = (($width * (($NouvelleHauteur * 100)/$height))/100 );

	                        $thumb_create = imagecreatetruecolor($NouvelleLargeur,$NouvelleHauteur);

	                        $white = imagecolorallocate($thumb_create, 255, 255, 255);
	                        imagefill($thumb_create, 0, 0, $white);

	                        switch($file_ext)
	                        {
	                            case 'jpg':
	                                $source = imagecreatefromjpeg($upload_image);
	                                break;
	                            case 'jpeg':
	                                $source = imagecreatefromjpeg($upload_image);
	                                break;
	                            case 'png':
	                                $source = imagecreatefrompng($upload_image);
	                                break;
	                            case 'gif':
	                                $source = imagecreatefromgif($upload_image);
	                                break;
	                            case 'bmp':
	                                $source = imagecreatefrombmp($upload_image);
	                                break;
	                            default:
	                                $source = imagecreatefromjpeg($upload_image);
	                        }

	                        imagecopyresampled($thumb_create , $source, 0, 0, 0, 0, $NouvelleLargeur, $NouvelleHauteur, $width,$height);

	                        $size = min(imagesx($thumb_create), imagesy($thumb_create));
	                        $im2 = imagecrop($thumb_create, ['x' => 0, 'y' => 0, 'width' => $size, 'height' => $size]);

	                        switch($file_ext)
	                        {
	                            case 'jpg' || 'jpeg':
	                            //	imagejpeg($thumb_create,$upload_image);
	                                imagejpeg($im2,$thumbnail,100);
	                                break;
	                            case 'png':
	                            //	imagepng($thumb_create,$upload_image);
	                                imagepng($im2,$thumbnail,100);
	                                break;
	                            case 'gif':
	                            //	imagegif($thumb_create,$upload_image);
	                                imagegif($im2,$thumbnail,100);
	                                break;
	                            default:
	                            //	imagejpeg($thumb_create,$upload_image);
	                                imagejpeg($im2,$thumbnail,100);
	                                break;
	                        }
	                        imagedestroy($im2);

	                        $params['url'] = $controller::DATA_PLANS . $_FILES['hiddenfile']['name'];
	                    }
	                    else
	                    {
	                        throw new Exception('File not downloaded ');
	                    }
	                }
	            }
	            else
	            {
	                $url = explode('min_',$_POST['imageHeader']);
	                $params['url'] = $controller::DATA_PLANS . $url[1];
	            }

				// Update plan parameters (ressources, refresh)
				if(isset($_POST['cbRessources'])&&!empty($_POST['cbRessources'])) $params['ressources'] = $_POST['cbRessources'];
				else $params['ressources'] = 'off';

				if(isset($_POST['refresh'])&&!empty($_POST['refresh'])) $params['refresh'] = $_POST['refresh'];
				else $params['refresh'] = 0;

				// Update the plan in DB
				$paramsSave = json_encode($params);
				Model_plan::updatePlan($dbconnection, $planId, $name, $type, $paramsSave, $parent);

				$smarty->assign('success_message', $lang['PLAN_UPD_OK']);

				// Update $plan var with new params for administration
				$planArr = Model_plan::getPlan($dbconnection, $planId);
				$plan = $planArr[$planId];
			}
			catch (EsiaDbException $e)
			{
				$errors[] = $e->getMessage();
			}
			catch (Exception $e)
			{
				$errors[] = $e->getMessage();
			}
		}
	}
	else {
		$errors[] = $lang['PLAN_USER_PERMS_DENIED'];
	}

	$action = 'admin';
}

// Main actions
if($action == 'plan' || $action == 'dash_plan')
{
	$plan['params'] = json_decode($plan['params'], true); // Decode plan params
	$smarty->assign('plan', $plan);
	$smarty->assign('type', $plan['type_name']);
	$smarty->assign('help', $lang['PLAN_HELP_IMG']); // Get plan view help text
	// Fetch plan objects & status
	$objects = $controller->getObjectsStateIcon($path, $planId);
	$smarty->assign('objects', $objects);
}
elseif($action == 'admin')
{
	if(!$controller->isUserPerms['admin'] || !$isUserPlanPrivilege['WRITE'])
	{
		$smarty->display('no_access.html');
		exit(0);
	}

	$plan['params'] = json_decode($plan['params'], true);
	$smarty->assign('plan', $plan);
	$smarty->assign('type', $plan['type_name']);

	// Get folder list wich user has write privilege to move plan into folder
	$moveFoldersList = $controller->getMoveFoldersList($lang['PLAN_FOLDER_ROOT'], $plan['folders'], null);
	$smarty->assign('moveFoldersList', $moveFoldersList);
	// Get users read & write access
	$usersList = Model_adm::searchUser($dbconnection, null);
	$smarty->assign('usersList', $usersList);
	$planUsersAccess = Model_Plan::getPlanUserAccess($dbconnection, $planId);
	$smarty->assign('planUsersAccess', $planUsersAccess);

	// Get Icons menu list
	$icons = Model_plan::getIconByGroups($dbconnection);
	$smarty->assign('icons', $icons);
	// Get plan objects
	$objects = Model_plan::getObjectsByPlan($dbconnection, $planId);
	foreach($objects as $key => $object)
	{
		$objects[$key]['params'] = json_decode($object['params'], true);
		$objects[$key]['icon'] = Model_plan::getIcon($dbconnection, $object['icon_id'])[0];
	}
	$smarty->assign('objects', $objects);

	// Get background images list
	$ListPictureName = $controller->listPictureName($controller->pathDataPlans . "miniature/");
	$url = explode($controller::DATA_PLANS, $plan['params']["url"]);
	$smarty->assign('imageHeader', "min_" . $url[1]);
	$smarty->assign('ListPictureName', $ListPictureName);
	$smarty->assign('whiteBackground', 'min_empty.jpg');
}

$smarty->assign('action', $action);

$typeControllerPath = $controller->pluginURL . explode('?', $plan['type_controller'])[0];
$smarty->assign('typeControllerPath', $typeControllerPath);

// NAVBAR
$foldersParentsTree = Model_plan::getFolders($dbconnection, $plan['folders']);
$controller->setNavBar($navbar, $lang['WEBP_PLAN'], $foldersParentsTree, null, $plan);

$smarty->assign('error_messages', $errors);


$smarty->display($controller->templatePath . 'plan_image.html');

?>
