<?php
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/common.php';
include_once $path . '/Model_adm.php';
include_once '../Model_plan.php';
include_once '../Controller_plan.php';

$controller = new Controller_Plan($path, $dbconnection, $user);

// Text Object Min & Max styles Properties
const OBJ_TXT_STYLES_MIN = array(
	'fontSize' => 10,
	'bgOpacity' => 0,
	'borderWidth' => 0,
	'borderRad' => 0,
	'padding' => 0
);
const OBJ_TXT_STYLES_MAX = array(
	'fontSize' => 70,
	'bgOpacity' => 1,
	'borderWidth' => 10,
	'borderRad' => 200,
	'padding' => 100
);

$errors = array();

if(isset($_GET['action']))
{
	$action = $_GET['action'];
	$smarty->assign('action', $action);

	if($action == 'confObjText')
	{
		$planId = $_GET['plan'];
		$smarty->assign('planId', $planId);
		$obj = $_GET['obj'];
		$obj = json_decode($obj, true);
		$smarty->assign('object', $obj);
		$planSize = $_GET['planSize'];
		$planSize = json_decode($planSize, true);
		$smarty->assign('planSize', $planSize);
		$planType = Model_Plan::getPlanType($dbconnection,$planId)[0];
		$planController = $controller->pluginURL . explode('?', $planType['controller'])[0];
		$smarty->assign('planController', $planController);
		$limits = array(
			'min' => OBJ_TXT_STYLES_MIN,
			'max' => OBJ_TXT_STYLES_MAX
		);
		$smarty->assign('limits', $limits);

		$smarty->display($controller->templatePath . 'plan_tools.html');
	}
	elseif($action == 'updateObjText')
	{
		if(isset($_POST['params']) && json_decode($_POST['params']))
		{
			$obj = Model_plan::getObject($dbconnection, $_GET['object']);
			$params = checkObjTxtMinMaxStylesVal(json_decode($_POST['params']));
			$params = json_encode($params);

			try
			{
				$idUpd = Model_plan::updateObject($dbconnection, $obj['id'], $obj['plan_id'], $obj['name'], $obj['type'], $obj['icon_id'], $params, $obj['link']);
			}
			catch(EsiaDbException $e)
			{
				$errors[] = "ERROR update : " . $e->getMessage();
			}
		}
		else
		{
			$errors[] = "ERROR update : wrong object parameters type";
		}
	}

	$smarty->assign('error_messages', $errors);

}

// Check if a value is between min & max limits & return value between those limits
function checkObjTxtSingleStyleVal($val, $minMaxKey)
{
	// Be sure than val is a number
    $val = floatval($val); // float for opacity

    if ($val < OBJ_TXT_STYLES_MIN[$minMaxKey])
    {
		// If $val is < than min, set it equal to min
        $val = OBJ_TXT_STYLES_MIN[$minMaxKey];
    } elseif ($val > OBJ_TXT_STYLES_MAX[$minMaxKey])
    {
		// If $val is > than max, set it equal to max
        $val = OBJ_TXT_STYLES_MAX[$minMaxKey];
    }

    return $val;
}

// Check if all styles values are between they're min max limits
function checkObjTxtMinMaxStylesVal($params)
{
    // Font-size
    $params->style->fontSize = checkObjTxtSingleStyleVal($params->style->fontSize, 'fontSize');

    // Background-opacity
    $params->style->bgOpacity = checkObjTxtSingleStyleVal($params->style->bgOpacity, 'bgOpacity');

    // Border width
    $params->style->borderWidth = checkObjTxtSingleStyleVal($params->style->borderWidth, 'borderWidth');

    // Border radius
    $params->style->borderRadTopLeft = checkObjTxtSingleStyleVal($params->style->borderRadTopLeft, 'borderRad');
    $params->style->borderRadTopRight = checkObjTxtSingleStyleVal($params->style->borderRadTopRight, 'borderRad');
    $params->style->borderRadBottomLeft = checkObjTxtSingleStyleVal($params->style->borderRadBottomLeft, 'borderRad');
    $params->style->borderRadBottomRight = checkObjTxtSingleStyleVal($params->style->borderRadBottomRight, 'borderRad');

    // Padding
    $params->style->padTop = checkObjTxtSingleStyleVal($params->style->padTop, 'padding');
    $params->style->padBottom = checkObjTxtSingleStyleVal($params->style->padBottom, 'padding');
    $params->style->padLeft = checkObjTxtSingleStyleVal($params->style->padLeft, 'padding');
    $params->style->padRight = checkObjTxtSingleStyleVal($params->style->padRight, 'padding');

    return $params;
}

?>
